if($DamageType::SmasherRam $= "")
{
	AddDamageType("SmasherRam", 'Smasher <bitmap:Add-Ons/Gamemode_ZAPT/icons/ci_leaper> <bitmap:base/client/ui/ci/car> %1', 'Smasher %2 <bitmap:Add-Ons/Gamemode_ZAPT/icons/ci_leaper> <bitmap:base/client/ui/ci/car> %1', 1, 1);
}

if(!isObject(ZombieSmasherArmor))
{
	datablock PlayerData(ZombieSmasherArmor : PlayerStandardArmor)
	{
		// Standard Properties
		canJet			= false;
		canRide			= false;
		jetEnergyDrain		= 0;
		maxDamage		= 200; //x 1.5
		maxEnergy		= 200;
		maxTools		= 0;
		minJetEnergy		= 0;
		paintable		= false;
		uiName			= "Zombie - Smasher";
		rideAble		= true;
		showEnergyBar	= true;
		
		// Speed Properties
		runEnergyDrain = 0;
		runForce = 48 * 90;
		maxBackwardSpeed = 2 + 0;
		maxForwardSpeed = 3.5 + 0;
		maxSideSpeed = 3 + 0;
		minRunEnergy = 10;
		
		maxBackwardCrouchSpeed = 2 - 1;
		maxForwardCrouchSpeed = 3 - 1;
		maxSideCrouchSpeed = 2 - 1;
		
		jumpForce = 12 * 90;
		jumpEnergyDrain = 0;
		jumpDelay = 3;
		minJumpEnergy = 25;
		
		// Zombie Properties
		isZombieArmor	= true;
		zombieUIName	= "a Smasher Zombie";
		zombieDamage	= 15;
		zombieScale		= "1.5 1.5 1.5";
		zombieVelNull	= 0.4;
		
		// Zombie Hax
		fireRetardant = false;
		useSpecialOn["attack"] = true;
		
		zombieSpecial["Claw"] = true;
		zombieSpecial["Route"] = false;
		//zombieSpecial["See"] = false;
		zombieSpecial["Sight"] = true;
		zombieSpecial["Smash"] = false;
		zombieSpecial["Special"] = true;
		zombieSpecial["Wander"] = false;
		
		// Zombie Nodes
		zombieCrawl = false;
		
		zombieHideNodes = 0;
		zombieHideNode[1] = "";
		
		zombieShowNodes = 0;
		zombieSHowNode[1] = "";
		
		// Skincolor Properties
		skinColorRedMin = 0.550;
		skinColorRedMax = 0.650;
		
		skinColorGreenMin = 0.450;
		skinColorGreenMax = 0.550;
		
		skinColorBlueMin = 0.300;
		skinColorBlueMax = 0.400;
		
		skinColorSym = "";
	};
}

if(!isObject(ZombieSmasherChargingArmor))
{
	datablock PlayerData(ZombieSmasherChargingArmor : PlayerStandardArmor)
	{
		// Standard Properties
		canJet			= false;
		canRide			= false;
		jetEnergyDrain		= 0;
		maxDamage		= 200; //x 1.5
		maxEnergy		= 200;
		maxTools		= 0;
		minJetEnergy		= 0;
		paintable		= false;
		uiName			= "";
		rideAble		= true;
		showEnergyBar	= true;
		rechargeRate = 0;
		
		minImpactSpeed = 0;
		
		// Speed Properties
		runEnergyDrain = 1.5;
		runForce = 18 * 90;
		maxBackwardSpeed = 0 + 0;
		maxForwardSpeed = 20 + 0;
		maxSideSpeed = 0 + 0;
		minRunEnergy = 3;
		
		maxBackwardCrouchSpeed = 2 - 1;
		maxForwardCrouchSpeed = 3 - 1;
		maxSideCrouchSpeed = 2 - 1;
		
		jumpForce = 6 * 90;
		jumpEnergyDrain = 0;
		jumpDelay = 3;
		minJumpEnergy = 25;
		
		// Zombie Properties
		isZombieArmor	= true;
		zombieUIName	= "charging at high speed!";
		zombieDamage	= 15;
		zombieScale		= "1.5 1.5 1.5";
		zombieVelNull	= 0.1;
		
		// Zombie Hax
		fireRetardant = false;
		useSpecialOn["attack"] = true;
		
		zombieSpecial["Claw"] = true;
		zombieSpecial["Route"] = false;
		//zombieSpecial["See"] = false;
		zombieSpecial["Sight"] = false;
		zombieSpecial["Smash"] = false;
		zombieSpecial["Special"] = true;
		zombieSpecial["Wander"] = false;
		
		// Zombie Nodes
		zombieCrawl = false;
		
		zombieHideNodes = 0;
		zombieHideNode[1] = "";
		
		zombieShowNodes = 0;
		zombieSHowNode[1] = "";
		
		// Skincolor Properties
		skinColorRedMin = 1;
		skinColorRedMax = 1;
		
		skinColorGreenMin = 0.0;
		skinColorGreenMax = 0.0;
		
		skinColorBlueMin = 0.0;
		skinColorBlueMax = 0.0;
		
		skinColorSym = "";
	};
}

function ZombieSmasherArmor::zombieClaw(%this, %obj)
{
	//Smash + Claw for 15 energy
	//Claw for 6.5 energy
	%energy = %obj.getEnergyLevel();
	if(%energy < 6.5)
		return;
	
	%this.zombieSpecial["Claw"] = false;
	%val = Parent::zombieClaw(%this,%obj);
	%this.zombieSpecial["Claw"] = true;
	
	%energy = %obj.getEnergyLevel();
	if(%energy < 8.5)
		return;
	
	%energy -= 8.5; //6.5 for the claw attack
	
	%client = %obj.client;
	
	%scale = %obj.getScale();
	%scaleFactor = (getWord(%scale, 0) + getWord(%scale, 1) + getWord(%scale, 2)) / 3;
	
	// Aim Vector
	%start = %obj.getEyePoint();
	
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);
	
	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);
	
	%eXY = mSqrt(%eX*%eX+%eY*%eY);
	
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
	
	// Epicenter
	%epicenter = %obj.getHackPosition();
	%epicenter = vectorAdd(%epicenter, vectorScale(%aimVec,%scaleFactor));
	
	// Radius
	%radius = %scaleFactor/2;
	
	// Masks
	%masks = $TypeMasks::FxBrickObjectType;
	
	initContainerRadiusSearch(%epicenter,%radius,%masks);
	while(isObject(%hit = containerSearchNext()))
	{
		if(miniGameCanDamage(%hit, %obj) != 1)
			continue;
		
		%type = %hit.getType();
		if(!%type & $TypeMasks::FxBrickObjectType)
			continue;
		
		%maxVolume = 150 * %scaleFactor;
		%volume = %hit.getDatablock().getVolume();
		
		if(%hit.isIndestructable || %hit.dataBlock.indestructable || %volume > %maxVolume)
			continue;
		
		%energy -= (%volume / %maxVolume) * 30;
		%mini = getMiniGameFromObject(%obj);
		%time = (isObject(%mini) ? %mini.brickRespawnTime : $Pref::Server::BrickRespawnTime);
		
		%force = vectorScale(%aimVec, %scaleFactor*1.25);
		%hit.fakeKillBrick(%force, %time / 1000);
		
		if(%energy < 5)
			break;
	}
	
	%obj.setEnergyLevel(%energy);
	return %val;
}

function ZombieSmasherArmor::zombieSee(%this, %obj, %target)
{
	%this.zombieSpecial["Sight"] = false;
	%val = Parent::zombieSee(%this,%obj,%target);
	%this.zombieSpecial["Sight"] = true;
	
	if(%val == 1 && %obj.zombieHasTarget())
		%this.zombieSpecial(%obj);
	
	return %val;
}

function ZombieSmasherChargingArmor::zombieClaw(%this, %obj)
{
	return false;
}

function ZombieSmasherArmor::zombieSpecial(%this, %obj)
{
	if(%obj.isCrouched())
		return false;
	
	%start = %obj.getPosition();
	%end = vectorSub(%start, "0 0 1");
	%masks = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
	
	%ground = containerRayCast(%start, %end, %masks, %obj);
	
	if(!isObject(%ground))
	{
		return false;
	}
	
	%energy = %obj.getEnergyLevel();
	
	if(%energy >= 80)
	{
		%obj.changeDatablock(ZombieSmasherChargingArmor);
		if(isObject(%obj.client))
		{		
			if(isObject(%obj.client.camera))
			{
				%transform = %obj.getTransform();
				%obj.client.camera.setOrbitMode(%obj, %transform, 0.5, 8, 8, 1);
				%obj.client.camera.mode = "Orbit";
				%obj.client.setControlObject(%obj.client.camera);
			}
			else
				return;
		}
		
		%conn = new AIConnection()
		{
			bl_id = 1337;
			connected = 1;
			hasSpawnedOnce = 0;
			isSmasherZombieAI = 1;
		};
		MissionCleanup.add(%conn);
		%conn.chargingCheck = %conn.schedule($ZAPT::ThinkEvery,smasherSlowDownCheck,%obj);
		%conn.setControlObject(%obj);
		%conn.setMove("y",1);
		%obj.chargerConn = %conn;
		return true;
	}
	
	return false;
}

function ZombieSmasherChargingArmor::zombieSpecial(%this, %obj)
{
	return false;
}

function ZombieSmasherChargingArmor::onCollision(%this, %obj, %col, %pos, %vel)
{
	return Parent::onCollision(%this, %obj, %col, %pos, %vel);
}

function ZombieSmasherChargingArmor::onImpact(%this, %obj, %col, %pos, %vel)
{
	if(%vel > 7.5)
	{
		if(miniGameCanDamage(%obj, %col) == 1 && %col.getType() & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
		{
			%damage = (%vel / 7) * 10;
			if(%damage > 40)
				%damage = 40;
			%col.damage(%obj, %start, %damage, $DamageType::SmasherRam);
			%col.addVelocity(vectorAdd(vectorScale(%obj.getForwardVector(),%vel/3),"0 0" SPC %vel/4));
			%obj.setEnergyLevel(%obj.getEnergyLevel() - %vel);
			%vel = 1;
			
			%obj.changeDatablock(zombieSmasherArmor);
			%obj.spawnExplosion(playerSootProjectile,getWord(%obj.getScale(),2));
			if(isObject(%obj.chargerConn))
			{
				if(isObject(%obj.client))
					%obj.client.resetControlObject();
				%obj.chargerConn.schedule(0,delete);
			}
		}
		
		%energy = %obj.getEnergyLevel();
		//echo(%energy);
		//if(%energy < 10)
		//	return;
		
		%client = %obj.client;
		
		%scale = %obj.getScale();
		%scaleFactor = (getWord(%scale, 0) + getWord(%scale, 1) + getWord(%scale, 2)) / 3;
		
		// Epicenter
		%epicenter = %obj.getHackPosition();
		%epicenter = vectorAdd(%epicenter, vectorScale(%obj.getForwardVector(),%scaleFactor));
		
		// Radius
		%radius = %scaleFactor*%vel/15;
		if(%radius > 5)
			%radius = 5;
		
		// Masks
		%masks = $TypeMasks::FxBrickObjectType;
		
		initContainerRadiusSearch(%epicenter,%radius,%masks);
		while(isObject(%hit = containerSearchNext()))
		{
			if(miniGameCanDamage(%hit, %obj) != 1)
				continue;
			
			%type = %hit.getType();
			if(!%type & $TypeMasks::FxBrickObjectType)
				continue;
			
			%maxVolume = 150 * %scaleFactor;
			%volume = %hit.getDatablock().getVolume();
			
			if(%hit.isIndestructable || %hit.dataBlock.indestructable || %volume > %maxVolume)
				continue;
			
			//%energy -= (%volume / %maxVolume) * 10;
			%mini = getMiniGameFromObject(%obj);
			%time = (isObject(%mini) ? %mini.brickRespawnTime : $Pref::Server::BrickRespawnTime);
			
			%force = vectorScale(%obj.getForwardVector(), %scaleFactor*1.25);
			%hit.fakeKillBrick(%force, %time / 1000);
			
			//if(%energy < 5)
			//	break;
		}
		%obj.setEnergyLevel(%energy);
		%obj.schedule(10,setVelocity,vectorScale(%obj.getForwardVector(),%vel*4/5));
	}
	//return Parent::onImpact(%this, %obj, %col, %pos, %vel);
}

package SmasherZombie
{
	function AIConnection::onDrop(%client, %reason)
	{
		if(%client.isSmasherZombieAI)
		{
			%client.onClientLeaveGame();
			removeFromServerGuidList( %client.guid );
			removeTaggedString(%client.name);
			return;
		}
		return Parent::onDrop(%client, %reason);
	}
	
	function messageClient(%client, %msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10, %a11, %a12, %a13)
	{
		if(isObject(%client) && %client.getClassName() $= "AIConnection")
			return;
		
		return Parent::messageClient(%client, %msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10, %a11, %a12, %a13);
	}
	
	function AIConnection::smasherSlowDownCheck(%this,%obj)
	{
		if(!isObject(%obj) || %this.getControlObject() != %obj || %obj.getState() $= "Dead")
		{
			%this.delete();
			return;
		}
		
		if(vectorLen(%obj.getVelocity()) <= 1 || %obj.zombieInWater)
		{
			%obj.playThread(3,undo);
			%obj.changeDatablock(zombieSmasherArmor);
			%obj.spawnExplosion(playerSootProjectile,getWord(%obj.getScale(),2));
			%this.schedule(500,delete);
			%obj.setEnergyLevel(%obj.getEnergyLevel() - 50);
			if(isObject(%obj.client))
				%obj.client.schedule(500,resetControlObject);
			
			%this.setMove("y",0);
			return;
		}
		%obj.unMountImage(3);
		%obj.schedule(10,mountImage,playerTeleportImage,3);
		%this.chargingCheck = %this.schedule($ZAPT::ThinkEvery,smasherSlowDownCheck,%obj);
	}
	
	function GameConnection::resetControlObject(%this)
	{
		if(isObject(%this.player))
			%this.setControlObject(%this.player);
	}
	
	function Observer::onTrigger(%this,%obj,%trigger,%state)
	{
		if(!isObject(%obj.getControllingClient()))
			return Parent::onTrigger(%this,%obj,%trigger,%state);
		%client = %obj.getControllingClient();
		
		if(!isObject(%client.player.chargerConn))
			return Parent::onTrigger(%this,%obj,%trigger,%state);
		
		switch(%trigger)
		{
			case 2:
				%client.player.chargerConn.setTrigger(2,%state);
		}
		
		return Parent::onTrigger(%this,%obj,%trigger,%state);
	}
};activatePackage(SmasherZombie);