$ZAPT::ArmyName = "Rescue";
$ZAPT::MaxHordeZombies = 30;
$ZAPT::DefaultDirectorMode = "Mobs";
package ZAPTDirectorSpawns
{
	function ZombieDirector::pickSpawnPoint(%so, %client)
	{
		%mini = getMiniGameFromObject(%client);
		
		if(!isObject(%mini))
			return "";
		
		%ss = %so.zombieKeeper;
		
		if(!isObject(%ss))
		{
			echo("\c2CRITICAL ERROR: ZombieDirector.zombieKeeper not found!");
			return "";
		}
		
		%spawns = 0;
		%spawnList = "";
		
		%spawnsSecondary = 0;
		%spawnListSecondary = "";
		
		for(%a = 0; %a < %ss.getCount(); %a++)
		{
			%spawn = %ss.getObject(%a);
			%spawnMini = getMiniGameFromObject(%spawn);
			
			if(!isObject(%spawnMini))
				continue;
			
			if(%spawnMini.getID() != %mini.getID())
				continue;
			
			if(zombieValidSpawnBrick(%brick))
			{
				if(!%spawns)
				{
					%spawnList = %spawn.getID();
				}
				else
				{
					%spawnList = %spawnList TAB %spawn.getID();
				}
				
				%spawns++;
			}
			
			if(!%spawnsSecondary)
			{
				%spawnListSecondary = %spawn.getID();
			}
			else
			{
				%spawnListSecondary = %spawnListSecondary TAB %spawn.getID();
			}
			
			%spawnsSecondary++;
		}
		
		if(%spawns)
		{
			%list = %spawnList;
			%count = %spawns;
		}
		else if(%spawnsSecondary)
		{
			%list = %spawnListSecondary;
			%count = %spawnsSecondary;
		}
		else
			return "";
		
		%spawnBrick = getField(%list, getRandom(0, %count - 1));
		%spawnPoint = %spawnBrick.getSpawnTransform();
		
		%client.zombieSpawnBrick = %spawnBrick;
		return %spawnPoint;
	}
	
	function ZombieDirector::pickMobSpawn(%so, %mini, %closestSpawn, %client)
	{
		if(!isObject(%mini))
			return "";
		%ss = %so.mobSpawnsKeeper;
		if(!isObject(%ss))
		{
			echo("\c2CRITICAL ERROR: ZombieDirector.mobSpawnsKeeper not found!");
			return "";
		}
		
		%spawns = 0;
		%spawnList = "";
		
		%spawnsSecondary = 0;
		%spawnListSecondary = "";
		
		for(%a = 0; %a < %ss.getCount(); %a++)
		{
			%spawn = %ss.getObject(%a);
			%spawnMini = getMiniGameFromObject(%spawn);
			
			if(!isObject(%spawnMini))
				continue;
			
			if(%spawnMini.getID() != %mini.getID())
				continue;
			
			if(zombieValidSpawnBrick(%brick))
			{
				if(!%spawns)
				{
					%spawnList = %spawn.getID();
				}
				else
				{
					%spawnList = %spawnList TAB %spawn.getID();
				}
				
				%spawns++;
			}
			
			if(!%spawnsSecondary)
			{
				%spawnListSecondary = %spawn.getID();
			}
			else
			{
				%spawnListSecondary = %spawnListSecondary TAB %spawn.getID();
			}
			
			%spawnsSecondary++;
		}
		
		if(%spawns)
		{
			%list = %spawnList;
			%count = %spawns;
		}
		else if(%spawnsSecondary)
		{
			%list = %spawnListSecondary;
			%count = %spawnsSecondary;
		}
		else
		{
			//error("NO SPAWNS??");
			return "";
		}
		
		if(isObject(%client) && !%client.isZombie && isObject(%client.player))
		{
			%testPos = %client.player.getPosition();
		}
		else if(%closestSpawn)
		{
			%avgPos = "0 0 0";
			%humanCount = 0;
			for(%a = 0; %a < %mini.numMembers; %a++)
			{
				%member = %mini.member[%a];
				
				if(!%member.isZombie && isObject(%member.player))
				{
					%humanCount++;
					%memberPos[%a] = %member.player.getPosition();
					%avgPos = vectorAdd(%avgPos,%memberPos[%a]);
				}
			}
			if(%humanCount == 0)
			{
				%spawnBrick = getField(%list, getRandom(0, %count - 1));
				return %spawnBrick;
			}
			%avgPos = vectorScale(%avgPos,1/%humanCount);
			
			%maxDist = 0;
			for(%a = 0; %a < %mini.numMembers; %a++)
			{
				%member = %so.member[%a];
				
				if(!%member.isZombie && isObject(%member.player))
				{
					if((%curDist = vectorDist(%avgPos,%memberPos[%a])) > %maxDist)
					{
						%testPos = %memberPos[%a];
						%maxDist = %curDist;
					}
				}
			}
		}
		else
		{
			%spawnBrick = getField(%list, getRandom(0, %count - 1));
			return %spawnBrick;
		}
		
		%minDist = -1;
		%spawnBrick = getField(%list, getRandom(0, %count - 1));
		for(%i=0;%i<%count;%i++)
		{
			%test = getWord(%list,%i);
			%curDist = vectorDist(%test.getWorldBoxCenter(),%testPos);
			if(%minDist == -1 || (%curDist < %minDist))
			{
				%minDist = %curDist;
				%spawnBrick = %test;
			}
		}
		
		return %spawnBrick;
	}

	function ZombieDirector::spawnMob(%so, %mini, %num, %closestSpawn, %client)
	{
		if(!isObject(%mini))
			return "";
		
		%ss = %so.mobSpawnsKeeper;
		if(!isObject(%ss))
		{
			echo("\c2CRITICAL ERROR: ZombieDirector.mobSpawnsKeeper not found!");
			return "";
		}
		
		%zz = %so.mobZombiesKeeper;
		if(!isObject(%zz))
		{
			echo("\c2CRITICAL ERROR: ZombieDirector.mobZombiesKeeper not found!");
			return "";
		}
		
		%spawn = %so.pickMobSpawn(%mini,%closestSpawn,%client);
		if(!isObject(%spawn))
			return;
		
		%list = "";
		
		%spawnTrans = %spawn.getSpawnTransform();
		%spawnPos = posFromTransform(%spawnTrans);
		%spawnRot = rotFromTransform(%spawnTrans);
		
		%sv = %spawn.vehicle;
		%svd = %spawn.vehicleDatablock;
		%sbt = %spawn.dataBlock.specialBrickType;
		
		%spawn.vehicleDatablock = ZombieStandardArmor;
		%spawn.dataBlock.specialBrickType = "VehicleSpawn";
		
		%diff = (ZombieMobKeeper.getCount() + %num) - $ZAPT::MaxHordeZombies;
		if(%diff > 0)
		{
			ZombieDirector.getMobZombieList(%mini);
			%count = getWordCount(ZombieDirector.mobZombiesList);
			for(%i=0;%i<%diff;%i++)
			{
				%obj = getWord(ZombieDirector.mobZombiesList,%count-%i-1);
				if(isObject(%obj))
					%obj.delete();
			}
		}
		
		for(%i=0;%i<%num;%i++)
		{
			if(ZombieMobKeeper.getCount() >= $ZAPT::MaxHordeZombies)
				break;
			
			%spawn.vehicle = "";
			%spawn.spawnVehicle();
			
			if(!isObject(%spawn.vehicle))
				continue;
			
			ZombieMobKeeper.add(%spawn.vehicle);
			
			%angle = getRandom()*2*$pi;
			%radius = getRandom()*(%num-1);
			%rand = mSin(%angle)*%radius SPC mCos(%angle)*%radius SPC 0;
			%spawn.vehicle.setTransform(vectorAdd(%spawnPos,%rand) SPC %spawnRot);
			if(%list $= "")
				%list = %spawn.vehicle;
			else
				%list = %list SPC %spawn.vehicle;
		}
		
		%spawn.vehicle = %sv;
		%spawn.vehicleDatablock = %svd;
		%spawn.dataBlock.specialBrickType = %sbt;
		
		return %list;
	}
	
	function ZombieDirector::getMobZombieList(%so,%mini)
	{
		//if(getSimTime() - %so.lastMobSortTime < 1000)
		//{
		//	return %so.mobZombiesList;
		//}
		
		%avgPos = "0 0 0";
		%humanCount = 0;
		for(%a = 0; %a < %mini.numMembers; %a++)
		{
			%member = %mini.member[%a];
			if(!%member.isZombie && isObject(%member.player))
			{
				%humanCount++;
				%memberPos[%a] = %member.player.getPosition();
				%avgPos = vectorAdd(%avgPos,%memberPos[%a]);
			}
		}
		if(%humanCount == 0)
		{
			return %so.mobZombiesList;
		}
		%avgPos = vectorScale(%avgPos,1/%humanCount);
		%so.mobZombiesList = "";
		for(%i=0;%i<%so.mobZombiesKeeper.getCount();%i++)
		{
			%obj = %so.mobZombiesKeeper.getObject(%i);
			%obj.zombieDistance = vectorDist(%obj.getHackPosition(),%avgPos);
			
			if(%so.mobZombiesList $= "")
				%so.mobZombiesList = %obj;
			else
				%so.mobZombiesList = %so.mobZombiesList SPC %obj;
		}
		
		//echo("Sub Sort Starting...");
		%so.mobZombiesList = %so.mobZombieSubSort(%so.mobZombiesList);
		%so.lastMobSortTime = getSimTime();
		
		return %so.mobZombiesList;
	}
	
	function ZombieDirector::mobZombieSubSort(%so,%list)
	{
		//echo("Sort" SPC %list);
		%count = getWordCount(%list);
		if(%count <= 1)
			return %list;
		
		%test = getWord(%list,0);
		%testDist = %test.zombieDistance;
		
		//so i don't have to do a second if() for every repeat
		%lower = ".";
		%higher = ".";
		
		for(%i=1;%i<%count;%i++)
		{
			%word = getWord(%list,%i);
			if(%word.zombieDistance < %testDist)
				%lower = %lower SPC %word;
			else
				%higher = %higher SPC %word;
		}
		
		%lower = restWords(%lower);
		%higher = restWords(%higher);
		
		return trim(%so.mobZombieSubSort(%lower) SPC %test SPC %so.mobZombieSubSort(%higher));
	}
	
	function ZombieDirector::direct(%so)
	{
		Parent::direct(%so);
		
		// Direct Zombies
		%ss = %so.mobZombiesKeeper;
		
		if(isObject(%ss))
		{
			for(%a = 0; %a < %ss.getCount(); %a++)
			{
				%zombie = %ss.getObject(%a);
				
				if(isObject(%zombie) && %zombie.isZombie)
				{
					// Spaces out zombie thought as to ease computer load.
					%time = ($ZAPT::ThinkEvery / %ss.getCount()) * %a;
					%zombie.schedule(%time, "zombieThink");
				}
			}
		}
		else
		{
			echo("\c2CRITICAL ERROR: ZombieDirector.mobZombiesKeeper not found!");
		}
		
	}
	
	function Player::zombieBeacon(%obj, %time, %client)
	{
		%val = Parent::zombieBeacon(%obj, %time, %client);
		%mini = getMinigameFromObject(%obj);
		if(isObject(%mini) && isObject(%obj.client))
		{
			ZombieDirector.spawnMob(%mini, 10, 1, %obj.client);
		}
		return %val;
	}
	
	function MinigameSO::assembleZombieGame(%so)
	{
		%val = Parent::assembleZombieGame(%so);
		
		cancel(%so.zombieHordeSched);
		
		if(%so.ZAPT_Enabled && miniGameUsingTDMGameMode(%so))
		{
			//ZombieDirector.spawnMob(%so, 6, 0, -1);
			//ZombieDirector.spawnMob(%so, 6, 0, -1);
			//ZombieDirector.spawnMob(%so, 6, 0, -1);
			
			if($ZAPT::DefaultDirectorMode $= "Mobs")
				%so.zombieHordeSched = %so.schedule(getRandom(6,10)*1000,directMobSpawn);
		}
		return %val;
	}
	
	function MinigameSO::directMobSpawn(%so)
	{
		//echo("Spawning a horde");
		
		%stress = ZombieDirector.getStressLevel(%so);
		//localclientconnection.getID().centerprint("Current stress = " @ %stress,5);
		
		for(%a = 0; %a < %so.numMembers; %a++)
		{
			%member = %so.member[%a];
			
			if(!%member.isZombie && isObject(%member.player))
			{
				%curPos = %member.player.getPosition();
				if(%member.player.lastZAPTDirectPos !$= "" && vectorDist(%curPos,%member.player.lastZAPTDirectPos) < 3)
				{
					//%member.player.zaptCampingFlag++;
					%f = %member.player.zaptCampingFlag;
					if(%f > 0 && %f % 3 == 0)
					{
						if(%f >= 9)
						{
							%member.player.spawnExplosion(zombieMolotovProjectile,1,%member);
							%member.player.zaptCampingFlag = 0;
						}
						else if(%f >= 3)
						{
							%member.player.zombieBeacon(1000);
							//%member.player.zaptCampingFlag = 0;
						}
					}
					if(%f >= 3)
					{
						talk(%member.getPlayerName() SPC "is camping somewhere debug (" @ %f @ ")");
					}
				}
				else
					%member.player.zaptCampingFlag = "";
				%member.player.lastZAPTDirectPos = %curPos;
			}
		}
		
		ZombieDirector.spawnMob(%so, 6, 0, -1);
		ZombieDirector.spawnMob(%so, 6, 0, -1);
		
		%so.zombieHordeSched = %so.schedule(5000 + (%stress/3*70),directMobSpawn);
	}
	
	function ZombieDirector::getStressHealth(%so, %mini)
	{
		if(isObject(%mini) && %mini.ZAPT_Enabled)
		{
			%damage = 0;
			%maxDamage = 0;
			
			for(%a = 0; %a < %mini.numMembers; %a++)
			{
				%member = %mini.member[%a];
				
				if(!%member.isZombie && isObject(%member.player))
				{
					%damage += %member.player.getDamageLevel();
					%maxDamage += %member.player.getDatablock().maxDamage;
				}
			}
			
			return (%damage / %maxDamage);
		}
		else
		{
			error("Did not supply a ZAPT minigame.");
			return -1;
		}
	}
	
	function zombieValidSpawnBrick(%brick)
	{
		if(isObject(%brick))
		{
			%db = %brick.getDatablock();
			
			if(%db.isZombieSpawn)
			{
				%mini = getMiniGameFromObject(%brick);
				
				if(isObject(%mini))
				{
					%playerInArea = false;
					
					%start = vectorSub(%brick.getWorldBoxCenter(), "0 0" SPC (%db.brickSizeZ - 3) * 0.1) SPC getWords(%brick.getTransform(), 3, 6);
					%radius = 30;
					%searchMask = $TypeMasks::PlayerObjectType;
					
					initContainerRadiusSearch(%start, %radius, %searchMask);
					
					%masks = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
					
					while(isObject(%col = containerSearchNext()))
					{
						if(miniGameSame(%brick, %col) && !%col.isZombie && %col.getState() !$= "Dead")
						{
							%end = %col.getEyePoint();
							%hit = getWord(containerRayCast(%start, %end, %masks, %obj));
							
							if(isObject(%hit) && %hit.getID() == %col.getID())
							{
								%playerInArea = true;
								break;
							}
						}
					}
					
					if(%playerInArea)
					{
						return false;
					}
					else
					{
						return true;
					}
				}
				else
				{
					return true;
				}
			}
			else
			{
				return -1;
			}
		}
		else
		{
			return -1;
		}
	}
};activatePackage(ZAPTDirectorSpawns);

function fxDTSBrick::getSpawnTransform(%this)
{
   %trans = %this.getTransform();
   %pos = posFromTransform(%trans);
   %rot = rotFromTransform(%trans);
   
   if(fileName(%this.dataBlock.brickfile) $= "spawnPoint.blb")
      %pos = vectorSub(%pos,"0 0 1.25");
   else
      %pos = vectorAdd(%pos,"0 0 " @ %this.dataBlock.brickSizeZ*0.1);
   
   return %pos SPC %rot;
}

if(!isObject(ZombieMobSpawnsKeeper))
{
	new SimSet(ZombieMobSpawnsKeeper);
}

if(!isObject(ZombieMobKeeper))
{
	new SimSet(ZombieMobKeeper);
}

if(isObject(ZombieDirector))
{
	ZombieDirector.mobSpawnsKeeper = ZombieMobSpawnsKeeper;
	ZombieDirector.mobZombiesKeeper = ZombieMobKeeper;
}

if(!isObject(ZombieMobSpawn))
{
	datablock fxDTSBrickData(ZombieMobSpawn : brickSpawnPointData)
	{
		category = brickSpawnPointData.category;
		subCategory = "Zombies";
		brickFile = $ZAPT::FilePath::Bricks @ "tankSpawnPoint.blb";
		uiName = "Zombie Mob Spawn";
		iconName = $ZAPT::FilePath::Icons @ "Icon_ZombieSpawn";
		specialBrickType = "";
		
		isZombieSpawn = true;
		isZombieNormSpawn = true;
		isZombieTankSpawn = false;
	};
}

function ZombieMobSpawn::onPlant(%this, %brick)
{
	parent::onPlant(%this, %brick);
	
	if(isObject(%brick))
	{
		ZombieMobSpawnsKeeper.add(%brick);
	}
}

function ZombieMobSpawn::onDeath(%this, %brick)
{
	for(%i=0;%i<ZombieMobKeeper.getCount();%i++)
	{
		%z = ZombieMobKeeper.getObject(%i);
		if(%z.spawnBrick == %brick)
			%z.schedule(0,delete);
	}
	
	return Parent::onDeath(%this, %brick);
}

function ZombieMobSpawn::onRemove(%this, %brick)
{
	for(%i=0;%i<ZombieMobKeeper.getCount();%i++)
	{
		%z = ZombieMobKeeper.getObject(%i);
		if(%z.spawnBrick == %brick)
			%z.schedule(0,delete);
	}
	
	return Parent::onRemove(%this, %brick);
}

function Player::setRandomZombieDatablock(%this)
{
	%chance = getRandom();
	if(%chance < (1/3))
	{
		%data = ZombieStandardArmor;
	}
	else
	{
		%pick = getRandom(0,2);
		switch(%pick)
		{
			case 0: %data = ZombieBoomerArmor;
			case 1: %data = ZombieLeaperArmor;
			case 2: %data = ZombieSmasherArmor;
		}
	}
	%this.setDatablock(%data);
}