datablock PlayerData(ZombieTankArmor : PlayerStandardArmor)
{
		// Standard Properties
		canJet			= false;
		canRide			= false;
		jetEnergyDrain	= 0;
		maxDamage		= 450;
		maxEnergy		= 200;
		maxTools		= 0;
		minJetEnergy	= 0;
		paintable		= false;
		uiName			= "Zombie - Tank";
		rideAble		= true;
		showEnergyBar	= true;
		
		// Speed Properties
		runEnergyDrain = 0;
		runForce = 48 * 90;
		maxBackwardSpeed = 4 + 0;
		maxForwardSpeed = 5 + 0;
		maxSideSpeed = 4 + 0;
		minRunEnergy = 10;
		
		maxBackwardCrouchSpeed = 2 - 1;
		maxForwardCrouchSpeed = 3 - 1;
		maxSideCrouchSpeed = 2 - 1;
		
		jumpForce = 9 * 90;
		jumpEnergyDrain = 40;
		jumpDelay = 3;
		minJumpEnergy = 30;
		
		// Zombie Properties
		isZombieArmor	= true;
		isZombieTank	= true;
		zombieUIName	= "the Tank";
		zombieDamage	= 30; //15;
		zombieScale		= "2 2 2";
		zombieVelNull	= 0.1;
		
		// Zombie Hax
		fireRetardant = false;
		useSpecialOn["attack"] = true;
		
		zombieSpecial["Claw"] = false;
		zombieSpecial["Route"] = false;
		zombieSpecial["See"] = false;
		zombieSpecial["Smash"] = false;
		zombieSpecial["Special"] = true;
		zombieSpecial["Wander"] = false;
		
		// Zombie Nodes
		zombieCrawl = false;
		
		zombieHideNodes = 0;
		zombieHideNode[1] = "";
		
		zombieShowNodes = 0;
		zombieSHowNode[1] = "";
		
		// Skincolor Properties
		skinColorRedMin = 0.150;
		skinColorRedMax = 0.150;
		
		skinColorGreenMin = 0.150;
		skinColorGreenMax = 0.450;
		
		skinColorBlueMin = 0;
		skinColorBlueMax = 0;
		
		skinColorSym = "rg";
};

function ZombieTankArmor::zombieSpecial(%this, %obj)
{
	return %obj.zombieSmash();
}

function ZombieTankArmor::zombieClaw(%this, %obj)
{
	// Energy
	%energy = %obj.getEnergyLevel();
	
	if(%energy > 6.5 && (getSimTime() - %obj.lastTankPunchTime) > 500)
	{
		%obj.setEnergyLevel(%energy - 6.5);
		%obj.lastTankPunchTime = getSimTime();
		
		// Animation
		%obj.zombieCanActivate = true;
		%obj.playThread(0, "activate2");
		%obj.zombieCanActivate = false;
		
		// Start
		%start = %obj.getEyePoint();
		
		// End
		%fvec = %obj.getForwardVector();
		%fX = getWord(%fvec, 0);
		%fY = getWord(%fvec, 1);
		
		%evec = %obj.getEyeVector();
		%eX = getWord(%evec, 0);
		%eY = getWord(%evec, 1);
		%eZ = getWord(%evec, 2);
		
		%eXY = mSqrt((%eX * %eX) + (%eY * %eY));
		%aimVec = (%fX * %eXY) SPC (%fY * %eXY) SPC %eZ;
		
		%range = 3 * getWord(%obj.getScale(), 2);
		
		%end = vectorAdd(%start, vectorScale(%aimVec, %range));
		
		// Masks
		%masks = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);			
		%col = containerRayCast(%start, %end, %masks, %obj);
		
		if(isObject(%col) && miniGameSame(%obj, %col) && %col.getType() & $TypeMasks::PlayerObjectType)
		{
			if(miniGameCanDamage(%obj, %col))
			{
				%pos = %obj.getPosition();
				%damage = %obj.getDatablock().zombieDamage;
				if(miniGameFriendlyFire(%obj, %col))
				{
					%damage /= 2;
				}
				
				//Tank gets own damage credit
				
				//if(%col.zombieBeacon)
				//{
				//	%damageType = $DamageType::BoomerSwarm;
				//	
				//	if(!isObject(%obj.client) && isObject(%col.zombieBeaconClient))
				//	{
				//		%source = %col.zombieBeaconClient.player;
				//	}
				//	else
				//	{
				//		%source = %obj;
				//	}
				//}
				//else
				//{
					%damageType = $DamageType::Zombies;
					%source = %obj;
				//}
				
				%col.damage(%source, %pos, %damage, %damageType);
				if(%col.isMounted())
					%col.dismount();
				
				%dif = vectorNormalize(getWords(vectorSub(%col.getPosition(), %obj.getPosition()),0,1));
				//%newVec = (getWord(%dif,0) * %eXY) SPC (getWord(%dif,1) * %eXY) SPC getWord(%eZ,0);
				%newVec = (getWord(%dif,0) * %eXY) SPC (getWord(%dif,1) * %eXY) SPC 0.5;
				%col.setVelocity(vectorAdd(%col.getVelocity(), vectorScale(%newVec, %damage)));
				
				if(%obj.getDamageLevel())
				{
					if(%damage > %obj.getDamageLevel())
					{
						%heal = %obj.getDamageLevel();
					}
					else
					{
						%heal = %damage;
					}
					
					%obj.setDamageLevel(%obj.getDamageLevel() - getRandom(mFloor(%heal / 2), %heal));
				}
				
				%col.spawnExplosion(spearProjectile,1.5,-1);
				
				if(isObject(%obj.client))
				{
					commandToClient(%obj.client, 'centerPrint', "<font:impact:32>*SMASH*\n<font:impact:16>ANGRY TANK IS ANGRY.", 0.5);					}
			}
			else
			{
				return 0;
			}
			return %col;
		}
		else if(isObject(%col) && miniGameCanDamage(%obj,%col) && %col.getType() & $TypeMasks::VehicleObjectType)
		{
			%pos = %obj.getPosition();
			%source = %obj;
			%damage = %col.getDatablock().maxDamage;
			%damageType = $DamageType::Zombies;
			
			%col.damage(%source, %pos, %damage, %damageType);
			%obj.spawnExplosion(spearProjectile,1.5,-1);
			
			%p = new Projectile()
			{
				dataBlock = vehicleExplosionProjectile;
				initialPosition = %col.getWorldBoxCenter();
				initialVelocity = "0 0 1";
				sourceObject = %obj;
				client = %obj.client;
				sourceSlot = 0;
				originPoint = %col.getWorldBoxCenter();
			};
			
			//if you shouldn't be spawning this projectile then don't damage
			if(isObject(%p))
			{
				MissionCleanup.add(%p);
				%scaleFactor = getWord(%col.getScale(),2);
				%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
				%p.schedule(50,explode);
			}
			
			%dif = vectorNormalize(getWords(vectorSub(%col.getWorldBoxCenter(), %obj.getPosition()),0,1));
			%newVec = (getWord(%dif,0) * %eXY) SPC (getWord(%dif,1) * %eXY) SPC getWord(%eZ,0);
			//%newVec = (getWord(%dif,0) * %eXY) SPC (getWord(%dif,1) * %eXY) SPC 0.5;
			%col.setVelocity(vectorAdd(%col.getVelocity(), vectorScale(%newVec, 20)));
			%col.zombieTankPunched = 1;
			
			if(isObject(%obj.client))
			{
				commandToClient(%obj.client, 'centerPrint', "<font:impact:32>*SMASH*\n<font:impact:16>ANGRY TANK IS ANGRY.", 0.5);					}
		}
		else
		{
			%obj.lastTankPunchTime = getSimTime() - 500;
			return 0;
		}
	}
	else
	{
		return 0;
	}
}

package ZombieTankPunch
{
	function Vehicle::finalExplosion(%this)
	{
		if(%this.zombieTankPunched)
		{
			%this.zombieTankPunched = 0;
			%this.schedule(4000,finalExplosion);
			return;
		}
		%val = Parent::finalExplosion(%this);
		return %val;
	}
};activatePackage(ZombieTankPunch);