datablock ItemData(GasCanItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "add-ons/gamemode_zombie/GasCan.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Gas Can";
	iconName = "add-ons/gamemode_zombie/Icons/Icon_GasCan";
	doColorShift = false;
		//colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = GasCanImage;
	canDrop = true;
	
	isPickupItem = 1;
	pickupVehicle = GasCanCol;
};
function GasCanItem::onPickup(%this, %obj, %player)
{  
	ItemData::onPickup(%this, %obj, %player);
	for(%i=0;%i<5;%i++)
	{
		%toolDB = %player.tool[%i];
		if(%toolDB $= %this.getID())
		{
			servercmdUseTool(%player.client,%i);
			break;
		}
	}
}

datablock ShapeBaseImageData(GasCanImage)
{
   shapeFile = "add-ons/gamemode_zombie/GasCan.dts";
   emap = true;

   mountPoint = 0;
   offset = "-0.53 0.05 -0.7";
   rotation = "0 0 1 90";

   correctMuzzleVector = true;

   className = "WeaponImage";

   // Projectile && Ammo.
   item = GasCanItem;
   ammo = " ";
   projectile = hammerProjectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   //colorShiftColor = "0.471 0.471 0.471 1.000";

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]	= true;

	stateName[2]			= "Fire";
	stateTransitionOnTimeout[2]	= "Ready";
	stateTimeoutValue[2]		= 0.5;
	stateFire[2]			= true;
	stateSequence[2]		= "fire";
	stateScript[2]			= "onFire";
	stateWaitForTimeout[2]		= true;
	stateAllowImageChange[2]	= false;
	//stateSound[5]				= GasCanFireSound;
};

function GasCanImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);	
	%obj.playThread(2, armreadyboth);
	%obj.haspickupitem = 1;
}

function GasCanImage::onUnMount(%this,%obj,%slot)
{
	Parent::onUnMount(%this,%obj,%slot);	
	%obj.playThread(2, root);
	%this.onFire(%obj,%slot);
	
	schedule(10,0,fixArmReady,%obj);
}

function GasCanImage::onFire(%this, %obj, %slot)
{
	if(!%obj.haspickupitem)
		return;
	
	%obj.playThread(2, shiftdown);
	for(%i=0;%i<5;%i++)
	{
		%toolDB = %obj.tool[%i];
		if(%toolDB $= %this.item.getID())
		{
			%obj.tool[%i] = 0;
			%obj.weaponCount--;
			messageClient(%obj.client,'MsgItemPickup','',%i,0);
			break;
		}
	}
	
	if(!isObject(%obj.client.minigame))
	{
		%obj.haspickupitem = 0;
		%fvec = %obj.getForwardVector();
		%fX = getWord(%fvec,0);
		%fY = getWord(%fvec,1);
		
		%evec = %obj.getEyeVector();
		%eX = getWord(%evec,0);
		%eY = getWord(%evec,1);
		%eZ = getWord(%evec,2);
		
		%eXY = mSqrt(%eX*%eX+%eY*%eY);
		
		%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
		
		%rot = rotFromTransform(%obj.getTransform());
		%rot = getWords(%rot,0,2) SPC (getWord(%rot,3)*180/$pi);
		
		%item = new Item()
		{
			dataBlock = %this.item;
			position = vectorAdd(%obj.getHackPosition(),vectorScale(%aimVec,2));
			rotation = %rot;
			bl_id = %obj.client.bl_id;
			canPickup = 1;
			static = 0;
			createTime = getSimTime();
			player = %obj;
		};MissionCleanup.add(%item);
		%item.applyImpulse(%item.position,vectorscale(%aimVec,10));
		%item.schedule($Game::Item::PopTime,delete);
		%item.startfade(1000,$Game::Item::PopTime-1000,1);
		%obj.unMountImage(%slot);
		return;
	}
	
	%obj.haspickupitem = 0;
	serverCmdUnUseTool(%obj.client);
	%obj.sourcerotation = %obj.gettransform();
	
	%g = %obj.client.minigame.owner.brickgroup;
	for(%i=0;%i<%g.getCount();%i++)
	{
		if(%g.getObject(%i).dataBlock.specialbrickType $= "")
		{
			%brick = %g.getObject(%i);
			break;
		}
	}
	
	if(!isObject(%brick))
		return;
	
	//echo(%brick);

	%item = new WheeledVehicle() 
	{
		rotation = getwords(%obj.sourcerotation,3,6);
		datablock  = %this.item.pickupVehicle;
		creator = %obj.client.player;
	};
	
	missionCleanup.add(%item);
	//%item.schedule(60000,delete);
	//%item.startfade(5000,55000,1);
	%item.sourceobject = %obj;
	%item.spawnBrick = %brick;
	%second= getwords(%obj.gettransform(),3,6);
	%item.settransform(vectoradd(getwords(vectoradd(%obj.gettransform(),%obj.getforwardvector()),0,2),"0 0 1") SPC %second);
	
	//echo(%item.schedule(2000,setVelocity,vectorscale(%aimVec,10)));
}
datablock WheeledVehicleData(GasCanCol)
{
	category = "Vehicles";
	displayName = "";
	shapeFile = "add-ons/gamemode_zombie/GasCanCol.dts";
	emap = true;
	minMountDist = 0;
	numMountPoints = 0;
	
	maxDamage = 10;
	destroyedLevel = 10;
	energyPerDamagePoint = 1;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";
	massCenter = "0 0 0";
	//massBox = "2 5 1";
	
	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	//tireEmitter = TireEmitter; // All the tires use the same dust emitter
	
	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
	collisionTol = 0.1;        // Collision distance tolerance
	contactTol = 0.1;
	
	useEyePoint = false;	
	
	//defaultTire	= PropaneTankTire;
	//defaultSpring	= PropaneTankSpring;
	//flatTire	= PropaneTankFlatTire;
	//flatSpring	= PropaneTankFlatSpring;
	
	numWheels = 0;
	
	// Rigid Body
	mass = 800;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;
	
	// Engine
	engineTorque = 12000; //4000;       // Engine power
	engineBrake = 2000;         // Braking when throttle is 0
	brakeTorque = 50000;        // When brakes are applied
	maxWheelSpeed = 0;        // Engine scale by current speed / max speed
	
	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;
	
	// Energy
	maxEnergy = 5;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;
	
	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	//splashEmitter[0] = PropaneTankFoamDropletsEmitter;
	//splashEmitter[1] = PropaneTankFoamEmitter;
	//splashEmitter[2] = PropaneTankBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;
	
	//   explosion = VehicleExplosion;
	justcollided = 0;
	
	uiName = "";
	rideable = true;
	lookUpLimit = 0.65;
	lookDownLimit = 0.45;
	
	paintable = true;
	
	// damageEmitter[0] = PropaneTankBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;
	
	//damageEmitter[1] = PropaneTankBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;
	
	numDmgEmitterAreas = 1;
	
	initialExplosionProjectile = hammerProjectile;
	// initialExplosionOffset = 0;         //offset only uses a z value for now
	
	burnTime = 100;
	
	finalExplosionProjectile = "";
	//finalExplosionProjectile = vehicleFinalExplosionProjectile;
	finalExplosionOffset = 0.5;          //offset only uses a z value for now
	
	minRunOverSpeed    = 30;   //how fast you need to be going to run someone over (do damage)
	runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
	runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
	
	isPickupVehicle = 1;
	pickupImage = GasCanImage;
};

function GasCanCol::onAdd(%this,%obj)
{
}

package GasCanPackage
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock.isPickupItem)
		{
			if(!miniGameCanUse(%obj,%col) || %obj.getDamagePercent() >= 100 || %obj.isZombie || %obj.getMountedImage(0).item.isPickupItem || !%col.canPickup)
				return;
			
			%obj.mountImage(%col.dataBlock.image,0);
			%col.canPickup = 0;
			if(%col.static)
				%col.respawn();
			else
				%col.delete();
			
			return;
		}
		return Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
	
	function Vehicle::finalExplosion(%this)
	{
		if(%this.dataBlock.getID() == GasCanCol.getID())
		{
			%p = new Projectile()
			{
				dataBlock = ZombieMolotovProjectile;
				initialPosition = %this.getWorldBoxCenter();
				initialVelocity = "0 0 1";
				sourceObject = %this.lastDamageClient.player;
				client = %this.lastDamageClient;
				sourceSlot = 0;
				originPoint = %this.getWorldBoxCenter();
			};
			MissionCleanup.add(%p);
			%p.schedule(10,explode);
			%this.delete();
			return;
		}
		return Parent::finalExplosion(%this);
	}
	
	function Vehicle::burnLoop(%obj, %loopRuns, %loopDamage, %source)
	{
		%pos = %obj.getWorldBoxCenter();
		%damage = %obj.getDatablock().maxDamage;
		%damageType = $DamageType::Generic;
		
		%obj.schedule(1000,damage,%source, %pos, %damage, %damageType);
	}
	
	function Vehicle::onActivate(%this,%player,%client,%pos,%normal)
	{
		%val = parent::onActivate(%this,%player,%client,%pos,%normal);
		if(%this.dataBlock.isPickupVehicle && miniGameCanUse(%player,%this) && !(%player.getMountedImage(0).item.isPickupItem))
		{
			if(%player.isZombie)
			{
				%this.damage(%player, %pos, %player.dataBlock.zombieDamage, $DamageType::Generic);
			}
			else
			{
				%player.mountImage(%this.dataBlock.pickupImage,0);
				%this.delete();
			}
		}
		return %val;
	}
	
	function Armor::onDisabled(%this,%obj)
	{
		if(%obj.getMountedImage(0).item.isPickupItem)
		{
			%obj.getMountedImage(0).onFire(%obj,0);
		}
		return Parent::onDisabled(%this,%obj);
	}
};
activatePackage(GasCanPackage);