datablock ItemData(PropaneTankItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "add-ons/gamemode_zombie/propanetank.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Propane Tank";
	iconName = "add-ons/gamemode_zombie/Icons/Icon_Propane";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = PropaneTankImage;
	canDrop = true;
	
	isPickupItem = 1;
	pickupVehicle = PropaneTankCol;
};
function PropaneTankItem::onPickup(%this, %obj, %player)
{  
	ItemData::onPickup(%this, %obj, %player);
	for(%i=0;%i<5;%i++)
	{
		%toolDB = %player.tool[%i];
		if(%toolDB $= %this.getID())
		{
			servercmdUseTool(%player.client,%i);
			break;
		}
	}
}

datablock ShapeBaseImageData(PropaneTankImage : GasCanImage)
{
   shapeFile = "add-ons/gamemode_zombie/propanetank.dts";
   item = PropaneTankItem;
   
	doColorShift = true;
	colorShiftColor = PropaneTankItem.colorShiftColor;
};

function PropaneTankImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);	
	%obj.playThread(2, armreadyboth);
	%obj.haspickupitem = 1;
}

function PropaneTankImage::onUnMount(%this,%obj,%slot)
{
	Parent::onUnMount(%this,%obj,%slot);	
	%obj.playThread(2, root);
	%this.onFire(%obj,%slot);
	
	schedule(10,0,fixArmReady,%obj);
}

function PropaneTankImage::onFire(%this, %obj, %slot)
{
	GasCanImage::onFire(%this,%obj,%slot);
}

datablock ParticleData(PropaneTankSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.6;
	constantAcceleration = 0.0;
	lifetimeMS           = 350;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.2";
	colors[1]     = "1 1 1 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.3;

	useInvAlpha = true;
};

datablock ParticleEmitterData(PropaneTankSmokeEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 2;
   ejectionVelocity = 6;
   velocityVariance = 2;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 20;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PropaneTankSmokeParticle";

   uiName = "Propane Tank Smoke";
};

datablock WheeledVehicleData(PropaneTankCol : GasCanCol)
{
	shapeFile = "add-ons/gamemode_zombie/PropaneTankCol.dts";
	maxDamage = 1;
	burnTime = 2000;
	initialExplosionProjectile = hammerProjectile;
	finalExplosionProjectile = PropaneTankFinalExplosionProjectile;
	
	isPickupVehicle = 1;
	pickupImage = PropaneTankImage;
	
	damageEmitter[0] = PropaneTankSmokeEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;
	
	damageEmitter[1] = PropaneTankSmokeEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;
	
	numDmgEmitterAreas = 1;
};

function PropaneTankCol::onDisabled(%this,%obj)
{
	%obj.playAudio(0,sprayFireSound);
}

datablock DebrisData(PropaneTankDebris)
{
   emitters = "JeepDebrisTrailEmitter";

	shapeFile = "Add-Ons/Gamemode_zombie/PropaneTank.dts";
	lifetime = 3.0;
	minSpinSpeed = -500.0;
	maxSpinSpeed = 500.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(PropaneTankFinalExplosion : vehicleFinalExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   debris = PropaneTankDebris;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 20;
   debrisVelocity = 18;
   debrisVelocityVariance = 3;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.75;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 20;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 6;
   impulseForce = 1000;
   impulseVertical = 2000;

   //radius damage
   radiusDamage        = 250;
   damageRadius        = 6.0;

   //burn the players?
   playerBurnTime = 2000;
};

datablock ProjectileData(PropaneTankFinalExplosionProjectile : vehicleFinalExplosionProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = PropaneTankFinalExplosion;

   brickExplosionRadius = 4;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;             
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 10;
   
   uiName = "";
};

function PropaneTankCol::onAdd(%this,%obj)
{
   %obj.setNodeColor("ALL",%this.pickupImage.colorShiftColor);
}